;;; -*- Mode: Common-Lisp -*-


;This is a quickie way to use CLIM colors as a presentation type.
;All the color symbols present in the CLIM environment are maintained
;in a simple association list that the color presentation type uses.
;I thought I would add this to the library to save people the agony of
;typing all of these color symbols in. The presentation type allows the
;user to display a color palette with the good ole <cntrl-?> keystroke
;when accepting a color type.

;Written for CLIM 1.1 within the Franz Allegro Environment by
;curt@eraserhead.jpl.nasa.gov

(require :loop)

(defvar *Color-P* nil "Flag to indicate if your running on a color system")

(defvar *All-Colors*
    (list (list 'White
		(cons 'ghost-white +ghost-white+)
		(cons 'ivory +ivory+)
		(cons 'white +white+)
		(cons 'navajo-white +navajo-white+)
		(cons 'old-lace +old-lace+)
		(cons 'linen +linen+)
		(cons 'seashell +seashell+)
		(cons 'white-smoke +white-smoke+)
		(cons 'floral-white +floral-white+)
		(cons 'snow +snow+)
		(cons 'antique-white +antique-white+))
	  (list 'Purple
		(cons 'medium-purple +medium-purple+)
		(cons 'purple +purple+)
		(cons 'violet +violet+)
		(cons 'dark-violet +dark-violet+)
		(cons 'orchid +orchid+)
		(cons 'medium-orchid +medium-orchid+)
		(cons 'dark-orchid +dark-orchid+)
		(cons 'pale-violet-red +pale-violet-red+)
		(cons 'medium-violet-red +medium-violet-red+)
		(cons 'violet-red +violet-red+)
		(cons 'lavender +lavender+)
		(cons 'lavender-blush +lavender-blush+)
		(cons 'plum +plum+)
		(cons 'magenta +magenta+))
	  (list 'Blue
		(cons 'light-blue +light-blue+)
		(cons 'blue +blue+)
		(cons 'medium-blue +medium-blue+)
		(cons 'sky-blue +sky-blue+)
		(cons 'light-sky-blue +light-sky-blue+)
		(cons 'deep-sky-blue +deep-sky-blue+)
		(cons 'pale-turquoise +pale-turquoise+)
		(cons 'medium-turquoise +medium-turquoise+)
		(cons 'turquoise +turquoise+)
		(cons 'dark-turquoise +dark-turquoise+)
		(cons 'light-cyan +light-cyan+)
		(cons 'cyan +cyan+)
		(cons 'light-steel-blue +light-steel-blue+)
		(cons 'steel-blue +steel-blue+)
		(cons 'light-slate-blue +light-slate-blue+)
		(cons 'medium-slate-blue +medium-slate-blue+)
		(cons 'slate-blue +slate-blue+)
		(cons 'dark-slate-blue +dark-slate-blue+)
		(cons 'powder-blue +powder-blue+)
		(cons 'cornflower-blue +cornflower-blue+)
		(cons 'alice-blue +alice-blue+)
		(cons 'azure +azure+)
		(cons 'cadet-blue +cadet-blue+)
		(cons 'dodger-blue +dodger-blue+)
		(cons 'navy-blue +navy-blue+)
		(cons 'royal-blue +royal-blue+)
		(cons 'midnight-blue +midnight-blue+)
		(cons 'blue-violet +blue-violet+))
	  (list 'Green
		(cons 'pale-green +pale-green+)
		(cons 'green +green+)
		(cons 'dark-green +dark-green+)
		(cons 'light-sea-green +light-sea-green+)
		(cons 'medium-sea-green +medium-sea-green+)
		(cons 'sea-green +sea-green+)
		(cons 'dark-sea-green +dark-sea-green+)
		(cons 'medium-spring-green +medium-spring-green+)
		(cons 'spring-green +spring-green+)
		(cons 'olive-drab +olive-drab+)
		(cons 'dark-olive-green +dark-olive-green+)
		(cons 'medium-aquamarine +medium-aquamarine+)
		(cons 'aquamarine +aquamarine+)
		(cons 'mint-cream +mint-cream+)
		(cons 'chartreuse +chartreuse+)
		(cons 'lawn-green +lawn-green+)
		(cons 'forest-green +forest-green+)
		(cons 'lime-green +lime-green+)
		(cons 'green-yellow +green-yellow+))
	  (list 'Yellow
		(cons 'light-yellow +light-yellow+)
		(cons 'yellow +yellow+)
		(cons 'pale-goldenrod +pale-goldenrod+)
		(cons 'light-goldenrod +light-goldenrod+)
		(cons 'goldenrod +goldenrod+)
		(cons 'dark-goldenrod +dark-goldenrod+)
		(cons 'light-goldenrod-yellow +light-goldenrod-yellow+)
		(cons 'wheat +wheat+)
		(cons 'gold +gold+)
		(cons 'lemon-chiffon +lemon-chiffon+)
		(cons 'cornsilk +cornsilk+)
		(cons 'honeydew +honeydew+)
		(cons 'yellow-green +yellow-green+))
	  (list 'Orange
		(cons 'papaya-whip +papaya-whip+)
		(cons 'orange +orange+)
		(cons 'dark-orange +dark-orange+)
		(cons 'peach-puff +peach-puff+)
		(cons 'orange-red +orange-red+))
	  (list 'Brown
		(cons 'beige +beige+)
		(cons 'khaki +khaki+)
		(cons 'dark-khaki +dark-khaki+)
		(cons 'tan +tan+)
		(cons 'brown +brown+)
		(cons 'light-salmon +light-salmon+)
		(cons 'salmon +salmon+)
		(cons 'dark-salmon +dark-salmon+)
		(cons 'bisque +bisque+)
		(cons 'sienna +sienna+)
		(cons 'gainsboro +gainsboro+)
		(cons 'thistle +thistle+)
		(cons 'blanched-almond +blanched-almond+)
		(cons 'sandy-brown +sandy-brown+)
		(cons 'saddle-brown +saddle-brown+)
		(cons 'moccasin +moccasin+)
		(cons 'burlywood +burlywood+)
		(cons 'chocolate +chocolate+))
	  (list 'Red
		(cons 'red +red+)
		(cons 'light-coral +light-coral+)
		(cons 'coral +coral+)
		(cons 'light-pink +light-pink+)
		(cons 'pink +pink+)
		(cons 'hot-pink +hot-pink+)
		(cons 'deep-pink +deep-pink+)
		(cons 'misty-rose +misty-rose+)
		(cons 'indian-red +indian-red+)
		(cons 'maroon +maroon+)
		(cons 'rosy-brown +rosy-brown+)
		(cons 'firebrick +firebrick+)
		(cons 'tomato +tomato+)
		(cons 'peru +peru+))
	  (list 'Gray
		(cons 'dim-gray +dim-gray+)
		(cons 'light-gray +light-gray+)
		(cons 'gray +gray+)
		(cons 'light-slate-gray +light-slate-gray+)
		(cons 'slate-gray +slate-gray+)
		(cons 'dark-slate-gray +dark-slate-gray+)
		(cons 'black +black+)))
  "All Clim symbol specified colors commonly used in X-Windows")

(defun Retrieve-Color
    (COLOR-SYMBOL &optional (INVERT-P nil) (Error-P t) &aux COLOR)
  "(COLOR-SYMBOL &OPTIONAL INVERT-P ERROR-P)
Arguments COLOR-SYMBOL      A color symbol (i.e. 'pink)
          INVERT-P          nil - color consideration for foreground application
                            t - color consideration for background application
          ERROR-P           Flag for checking color validity
Returns   A valid color or +foreground+ or +background+ or nil depending on ERROR-P
Side-Effect
"
  (loop for i in *All-Colors*
      finally (return (cond (Error-P nil)
			    ((null INVERT-P) +foreground+) (t +background+)))
      do
	(when (and *Color-P* (setq COLOR (assoc COLOR-SYMBOL (cdr i))))
	  (return (cdr COLOR)))))

(define-presentation-type Color (&optional (INVERT-P nil))
  :history t :description "Clim colors commonly used in X-Windows")

(define-presentation-method presentation-typep (object (type Color))
  (declare (special *All-Colors*))
  (loop for i in *All-Colors* do
	(when (member object (cdr i) :key #'cdr)) (return t)))

(define-presentation-method presentation-subtypep ((type1 Color) type2)
  (let ((check-1 (with-presentation-type-parameters (Color type1) Invert-P))
	(check-2 (with-presentation-type-parameters (Color type2) Invert-P)))
    (values (eq check-1 check-2) t)))

(define-presentation-method describe-presentation-type
    ((type Color) stream plural-count &aux X Y)
  (declare (special *All-Colors* *Color-P*))
  (format stream "~a type color~@[s~]   "
	  (if Invert-P "background" "foreground")
	  (and (numberp plural-count) (> plural-count 1)))
  (with-text-size (:smaller stream)
    (formatting-table (Stream :inter-row-spacing 0 :inter-column-spacing 1)
     (loop for i in (cond (*Color-P* *All-Colors*) (t (last *All-Colors*))) do
	   (formatting-row (Stream)
	    (formatting-cell (Stream) (format Stream "~a" (car i)))
	    (multiple-value-setq (X Y) (window-viewport-position* Stream))
	    (loop for j in (cdr i) for k from X by 10 do
		  (formatting-cell (Stream)
		   (with-output-as-presentation (:object (cdr j) :type 'Color
						 :stream Stream :single-box t)
		     (draw-rectangle* Stream k Y (+ k 8) (+ Y 8)
				      :ink (cdr j))))))
	   (terpri Stream)))))

(define-presentation-method present
    (Color (type Color) stream (view textual-view) &key)
  (declare (special *All-Colors*))
  (let ((c-cons nil))
    (loop for i in *All-Colors*
	finally (write-string (cond ((null Invert-P) "foreground")
				    (t "background")) stream)
	do
	  (when (setq c-cons (car (member Color (cdr i) :key #'cdr)))
	    (return (write-string (string (car c-cons)) stream))))))

(define-presentation-method accept
    ((type Color) stream (view textual-view) &key)
  (let ((token (read-token stream)) a-color)
    (when (setq a-color (Retrieve-Color (read-from-string token nil nil)
					Invert-P nil))
      (return-from accept a-color))
    (input-not-of-required-type token type)))
